I'd like to return an exit code from a BASH script that is called within another script, but could also be called directly. It roughly looks like this:
#!/bin/bash dq2-get $1 if [ $? -ne 0 ]; then echo "ERROR: ..." # EXIT HERE fi # extract, do some stuff # ...
Now in the line EXIT HERE
the script should exit and return exit code 1. The problem is that
return
, because when I forget to source the script instead of calling it, return will not exit, and the rest of the script will be executed and mess things up. exit
, because this closes the shell.kill -SIGINT $$
, because this doesn't allow to return an exit code.Is there any viable alternative that I have overlooked?
Use return . The return bash builtin will exit the sourced script without stopping the calling (parent/sourcing) script. Causes a function to stop executing and return the value specified by n to its caller.
Normally the exit status is 0 if a line is selected, 1 if no lines were selected, and 2 if an error occurred. However, if the -q or --quiet or --silent option is used and a line is selected, the exit status is 0 even if an error occurred. Other grep implementations may exit with status greater than 2 on error.
Extracting the elusive exit code To display the exit code for the last command you ran on the command line, use the following command: $ echo $? The displayed response contains no pomp or circumstance. It's simply a number.
Hold Ctrl and press p q .
The answer to the question title (not in the body as other answers have addressed) is:
Return an exit code without closing shell
(exit 33)
If you need to have -e
active and still avoid exiting the shell with a non-zero exit code, then do:
(exit 33) && true
The true
command is never executed but is used to build a compound command that is not exited by the -e
shell flag.
That sets the exit code without exiting the shell (nor a sourced script).
For the more complex question of exiting (with an specific exit code) either if executed or sourced:
#!/bin/bash [ "$BASH_SOURCE" == "$0" ] && echo "This file is meant to be sourced, not executed" && exit 30 return 88
Will set an exit code of 30 (with an error message) if executed.
And an exit code of 88 if sourced. Will exit both the execution or the sourcing without affecting the calling shell.
Use this instead of exit or return:
[ $PS1 ] && return || exit;
Works whether sourced or not.
If you love us? You can donate to us via Paypal or buy me a coffee so we can maintain and grow! Thank you!
Donate Us With